 /***************************************************************************\
 * ThyAPI - Thyamad Javascript API - Cryptography Hash Element               *
 * http://thyapi.thyamad.com                                                 *
 *                                                                           *
 * Copyright (C) 2005 - Raphael Derosso Pereira                              *
 * Based on DynAPI v3.0b1                                                    *
 * ------------------------------------------------------------------------- *
 *  This library is free software; you can redistribute it and/or modify it  *
 *  under the terms of the GNU Lesser General Public License as published    *
 *  by the Free Software Foundation; either version 2.1 of the License,      *
 *  or any later version.                                                    *
 *  This library is distributed in the hope that it will be useful, but      *
 *  WITHOUT ANY WARRANTY; without even the implied warranty of               *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                     *
 *  See the GNU Lesser General Public License for more details.              *
 \***************************************************************************/


	/**
	 * Class: thyHash
	 *
	 *	Class that manages cryptography hash. It allow you to hash
	 *	things using one of the implemented cyphers. (Now there's just
	 *	MD5)
	 *
	 */
	function thyHash ()
	{
		this.thyBase = thyBase;
		this.thyBase();

		this.cipher = null;
	}

	p = dynapi.setPrototype('thyHash', 'thyBase');
	
	/**
	 * Method: setCypher
	 *
	 *	Sets the cypher to be used. Note that this method
	 *	will call library include method, meaning that the
	 *	the cypher will be available only on next run.
	 *
	 *	The only available cypher at the moment is blowfish.
	 *	(Rijndael comming...)
	 *
	 * Parameter:
	 *
	 *	cypher - The cypher type
	 *
	 */
	p.setCypher = function (cypher)
	{
		switch (cypher)
		{
			case 'md5':
				dynapi.library.include('thyHashMD5');
				var self = this;
				var create_cypher = function ()
				{
					if (window.thyHashMD5)
					{
						self = new thyHashMD5();
						return;
					}
					setTimeout(create_cypher, 100);
				}
				create_cypher();
				return;
		}
	}
	 
	/**
	 * Method: encode
	 *
	 *	Returns the base64 encoded hash of str
	 *
	 * Parameters:
	 *
	 *	str - The text to be encoded
	 *
	 * Returns:
	 *
	 *	Base64 encoded string
	 *
	 */
	p.encode = function (str, key)
	{
		throw({
			result:'Cypher not set or encode called before library inclusion. Call on next timeout', 
			location: 'thyHash.encode'
		});
	}

