 /*****************************************************************************\
 * ThyAPI - Thyamad Javascript API - Connection Protocol Element              *
 * http://www.thyamad.com                                                     *
 *                                                                            *
 * Copyright (C) 2005 - Raphael Derosso Pereira                               *
 * Based on DynAPI v3.0b1                                                     *
 * -------------------------------------------------------------------------  *
 *  This library is free software; you can redistribute it and/or modify it   *
 *  under the terms of the GNU Lesser General Public License as published     *
 *  by the Free Software Foundation; either version 2.1 of the License,       *
 *  or any later version.                                                     *
 *  This library is distributed in the hope that it will be useful, but       *
 *  WITHOUT ANY WARRANTY; without even the implied warranty of                *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                      *
 *  See the GNU Lesser General Public License for more details.               *
 \****************************************************************************/

	/**
	 * Protocol Abstract Class
	 *
	 * This class implements the commom functions of Protocols. This is just an
	 * abstract class. It MUST be derived and the methods MUST be implemented
	 * correctly.
	 *
	 * @abstract
	 * @author Raphael Derosso Pereira <raphael@thyamad.com>
	 * @copyright Copyright &copy; Raphael Derosso Pereira
	 */
	function thyProtocol(protocol, url)
	{
		this.thyBase = thyBase;
		this.thyBase();

		// Attributes
		switch(protocol)
		{
			case 'xmlrpc':
				return new thyXMLRPCProtocol(url);
		}
	}
	
	p = dynapi.setPrototype('thyProtocol','thyBase');

	/**
	 * Encode the data in this Protocols format
	 *
	 * This method MUST be implemented in derived class.
	 *
	 * @public
	 * @param string method Method name
	 * @param object param The data that is sent as Method Parameter
	 */
	p.encode = function (method, param)
	{
		throw('Protocol Abstract Class cannot be used as Object! Use one of the Derivate Classes');
	}

	/**
	 * Decode the data that is in this Protocols format
	 *
	 * This method MUST be implemented in derived class.
	 *
	 * @public
	 * @param string response The text returned by server
	 */
	p.decode = function (response)
	{
		throw('Protocol Abstract Class cannot be used as Object! Use one of the Derivate Classes');
	}

	/*************************************************************************\
	 *                          Private Methods                              *
	\*************************************************************************/
